// Grabby McScreenface (c) 2022 Timescale Technologies.
// Simple sketch that controls the bluetooth screengrab HID mounted in a Kodac Brownie camera.

#include <BleKeyboard.h>
BleKeyboard bleKeyboard("Brownie HID", "Timescale", 100);

#define LIGHT_SENSOR 36 
#define ROLLER_SWITCH 18
#define STATUS_LED 19

int shutterState = 0;
int isConnected = false;
int orientation;

void setup() {
  Serial.begin(115200);
  Serial.println("Grabby McScreenface.");
  pinMode(ROLLER_SWITCH, INPUT_PULLUP); // Used to determin orientation.
  pinMode(STATUS_LED, OUTPUT); // Status indicator light
  bleKeyboard.begin();
  // Signal power on.
  digitalWrite(STATUS_LED, HIGH);   
  delay(500);                     
  digitalWrite(STATUS_LED, LOW);   
  delay(1000); // Wait for one second before jumping into the think of things.                     
}

void loop() {
    if(bleKeyboard.isConnected()) {
       if (!isConnected){
        // give signal when Bluetooth connection is made.
        isConnected = true;
        digitalWrite(STATUS_LED, HIGH);   delay(200); // Blinkerty!                      
        digitalWrite(STATUS_LED, LOW);    delay(200);
        digitalWrite(STATUS_LED, HIGH);   delay(200); // Blink!                     
        digitalWrite(STATUS_LED, LOW);
        // we're in business now.
       }
       int analogValue = analogRead(LIGHT_SENSOR);
          if (analogValue > 2 && shutterState == 0){
            orientation = digitalRead(ROLLER_SWITCH);
            shutterState = 1;
            digitalWrite(STATUS_LED, HIGH);  
            if (orientation == 0){
              // protrait mode. Send capture window command.
               Serial.println("Window Capture");
            //    bleKeyboard.print("Window");
            //    delay(100);
                bleKeyboard.press(KEY_LEFT_SHIFT);
                bleKeyboard.press(KEY_LEFT_ALT);
                bleKeyboard.press(KEY_F1);
                delay(100);
                bleKeyboard.releaseAll();

            } else {
              // landscape mode. Send capture screen command.
               Serial.println("Screen Capture");
              //  bleKeyboard.print("Screen");
              //  delay(100);
                bleKeyboard.press(KEY_LEFT_SHIFT);
                bleKeyboard.press(KEY_LEFT_ALT);
                bleKeyboard.press(KEY_F2);
                delay(100);
                bleKeyboard.releaseAll();

            }
            
          }
          if (analogValue < 2 && shutterState == 1){
            // shutter closed. 
            shutterState = 0;
            digitalWrite(STATUS_LED, LOW);  
            delay(1000); // Incase somebody gets trigger happy!
          }
       }
       delay(30); // If the brownie is on bulb mode, this is fast enough.
}
